



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>最短路径算法-Dijkstra算法的应用之单词转换(词梯问题)(转)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">最短路径算法-Dijkstra算法的应用之单词转换(词梯问题)(转)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 18:49:36 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p><strong>一，问题描述</strong></p>
<p>在英文单词表中，有一些单词非常相似，它们可以通过只变换一个字符而得到另一个单词。比如：hive--&gt;five；wine--&gt;line；line--&gt;nine；nine--&gt;mine.....</p>
<p>那么，就存在这样一个问题：给定一个单词作为起始单词(相当于图的源点)，给定另一个单词作为终点，求从起点单词经过的最少变换(每次变换只会变换一个字符)，变成终点单词。</p>
<p>这个问题，其实就是最短路径问题。</p>
<p>由于最短路径问题中，求解源点到终点的最短路径与求解源点到图中所有顶点的最短路径复杂度差不多，故求解两个单词之间的最短路径相当于求解源点单词到所有单词之间的最短路径。</p>
<p>给定所有的英文单词，大约有89000个，我们需要找出通过单个字母的替换可以变成至少15个其他单词的单词？程序如何实现？</p>
<p>给定两个单词，一个作为源点，另一个作为终点，需要找出从源点开始，经过最少次单个字母替换，变成终点单词，这条变换路径中经过了哪些单词？</p>
<p>比如：(zero--&gt;five)：（zero--&gt;hero--&gt;here--&gt;hire--&gt;five）</p>
<p><strong>二，算法分析</strong></p>
<p>假设所有的单词存储在一个txt文件中，每行一个单词。</p>
<p>现在的问题主要有两个：①从文件中读取单词，并构造一个图；②图的最短路径算法--Dijkstra算法实现。</p>
<p>由于单词A替换一个字符变成单词B，那么反过来单词B替换一个字符也可以变成单词A（自反性）【wine--&gt;fine； fine--&gt;wine】。故图是一个无向图。</p>
<p><strong>构造图的算法分析：</strong></p>
<p>现在更进一步，假设单词已经读取到一个List&lt;String&gt;中，图采用邻接表形式存储，<a href="http://www.cnblogs.com/hapjin/p/4766823.html" rel="external nofollow noreferrer">构造图其实就是</a>：如何根据List&lt;String&gt; 构造一个Map&lt;String,List&lt;String&gt;&gt;</p>
<p>其中Map中的Key是某个单词，Value则是该单词的&ldquo;邻接单词&rdquo;列表，邻接单词即：该单词经过一个字符的替换变成另一个单词。</p>
<p>如：wine的邻接单词有：fine、line、nine.....</p>
<p>一个最直接的想法就是：</p>
<p>由于单词都在List&lt;String&gt;中存储，那么从第1个单词开始，依次扫描第2个至第N个单词，判断第1个单词是否与第 2,3,.....N个单词只差一个字符。这样一遍扫描，找出了List&lt;String&gt;中第1个单词的邻接表。</p>
<p>继续，对于第2个单词，依次扫描第3,4,....N个单词，找出List&lt;String&gt;中第2个单词的邻接表。</p>
<p>.......</p>
<p>上述过程可描述成如下循环：</p>
<div>
<pre class="prettyprint linenums">    for(int i = 0; i &lt; N; i++)<br />
        for(int j = i+1; j &lt; N; j++)//N 表示单词表中所有单词个数<br />            //do something....</pre>
</div>
<p>显然，上述构造图的算法的时间复杂度为O(N^2)。具体代码如下：</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums"> 1     public static Map&lt;String, List&lt;String&gt;&gt; computeAdjacentWords2(List&lt;String&gt; theWords){<br />
 2         Map&lt;String, List&lt;String&gt;&gt; adjWords = new TreeMap&lt;&gt;();<br />
 3         String[] words = new String[theWords.size()];<br />
 4         words = theWords.toArray(words);<br />
 5<br />
 6         for(int i = 0; i &lt; words.length; i++)<br />
 7             for(int j = i+1; j &lt; words.length; j++)//在整个单词表中的所有单词之间进行比较<br />
 8                 if(oneCharOff(words[i], words[j]))<br />
 9                 {<br />
10                     update(adjWords, words[i], words[j]);//无向图,i--j<br />
11                     update(adjWords, words[j], words[i]);//j--i<br />
12                 }<br />
13         return adjWords;<br />
14     }</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>注意第4行，它将List转换成了数组，这样可以提高程序的执行效率。因为，若不转换成数组，在随后的第6、7行for循环中，在执行时泛型擦除，将频繁向下转型（Object转型成String）</p>
<p>另外两个工具方法如下：</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">//判断两个单词 只替换一个字符变成另一单词<br />
    private static boolean oneCharOff(String word1, String word2) {<br />
        if (word1.length() != word2.length())//单词长度不相等,肯定不符合条件.<br />
            return false;<br />
        int diffs = 0;<br />
        for (int i = 0; i &lt; word1.length(); i++)<br />
            if (word1.charAt(i) != word2.charAt(i))<br />
                if (++diffs &gt; 1)<br />
                    return false;<br />
        return diffs == 1;<br />
    }

    //将单词添加到邻接表中<br />
    private static &lt;T&gt; void update(Map&lt;T, List&lt;String&gt;&gt; m, T key, String value) {<br />
        List&lt;String&gt; lst = m.get(key);<br />
        if (lst == null) {//该 Key是第一次出现<br />
            lst = new ArrayList&lt;String&gt;();<br />
            m.put(key, lst);<br />
        }<br />
        lst.add(value);<br />
    }</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p><strong>Dijkstra算法分析：</strong></p>
<p>上面已经提到，这是一个无向图，无向图的最短路径问题，无向图的Dijkstra算法实现要比带权的有向图简单得多。简单的原因在于：无向图的Dijkstra实现只需要一个队列，采用&ldquo;广度&rdquo;遍历的思想从源点开始向外扩散求解图中其他顶点到源点的距离，<strong>之所以这样，是因为无向图一旦访问到某个顶点，更新它的前驱顶点后，它的前驱顶点以后都不会再变了（<a href="http://www.cnblogs.com/hapjin/p/5435724.html" rel="external nofollow noreferrer">参考博文</a>）。而对于有向图，某个顶点的前驱顶点可能会被多次更新。因此，需要更复杂的数据结构来&rdquo;贪心&ldquo;选择下一个距离最短的顶点。</strong></p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums"> 1 /**<br />
 2  * 使用Dijkstra算法求解无向图 从 start 到 end 的最短路径<br />
 3  * @param adjcentWords 保存单词Map,Map&lt;String, List&lt;string&gt;&gt;key:表示某个单词, Value:与该单词只差一个字符的单词<br />
 4  * @param start 起始单词<br />
 5  * @param end 结束单词<br />
 6  * @return 从start 转换成 end 经过的中间单词<br />
 7  */<br />
 8     public static List&lt;String&gt; findChain(Map&lt;String, List&lt;String&gt;&gt; adjcentWords, String start, String end){<br />
 9         Map&lt;String, String&gt; previousWord = new HashMap&lt;String, String&gt;();//Key:某个单词,Value:该单词的前驱单词<br />
10         Queue&lt;String&gt; queue = new LinkedList&lt;&gt;();<br />
11<br />
12         queue.offer(start);<br />
13         while(!queue.isEmpty()){<br />
14             String preWord = queue.poll();<br />
15             List&lt;String&gt; adj = adjcentWords.get(preWord);<br />
16<br />
17             for (String word : adj) {<br />
18                 //代表这个word的'距离'(前驱单词)没有被更新过.(第一次遍历到该word),每个word的'距离'只会被更新一次.<br />
19                 if(previousWord.get(word) == null){//理解为什么需要if判断<br />
20                     previousWord.put(word, preWord);<br />
21                     queue.offer(word);<br />
22                 }<br />
23<br />
24             }<br />
25         }<br />
26         previousWord.put(start, null);//记得把源点的前驱顶点添加进去<br />
27         return geChainFromPreviousMap(previousWord, start, end);<br />
28     }</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>第19行进行if判断的原因是：还是前面提到的，每个顶点的前驱只会更新一次。当第一次遍历到 'word'时，它的前驱顶点'preWord'就被永久确定下来了。</p>
<p>当在后面可能再次从另外一个顶点遍历到该'word'时，这个顶点不可能是'word'的前驱顶点了。因为：这条到'word'的路径不可能是最短的了。这就是&rdquo;广度&ldquo; 搜索的思想！</p>
<p><strong>三，构造图的算法改进</strong></p>
<p>这里将构造图的算法改进单独作为一节，是因为它很好地用到了&ldquo;分类的思想&rdquo;，在处理大量的数据时，先将相关的数据分类，然后以类为单位，一个一个地处理类中的所有数据。</p>
<p><strong>分类要覆盖所有的数据，相当于概率论中的对 数据集合S的一个全划分。</strong></p>
<p>将列表List&lt;String&gt;中的单词构造图，本质上查找每个单词的所有邻接单词。显然如果两个单词的长度不相等，它们就不可能构成邻接关系。</p>
<p>因此，可以把单词表中所有的单词先按单词的长度进行分类，分成长度为1的单词、长度为2的单词....长度为N的单词。分成了N个集合，这N个集合就是单词表的一个全划分，因为对于单词表中的任何一个单词，它一定属于这N个集合中的某一个。</p>
<p>因此，先将按长度进行分类。然后再对每一类中的单词进行判断。改进后的代码如下：</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums"> 1     /**<br />
 2      * 根据单词构造邻接表<br />
 3      * @param theWords 包含所有单词List<br />
 4      * @return Map&lt;String, List&lt;string&gt;&gt;key:表示某个单词, Value:与该单词只差一个字符的单词<br />
 5      */<br />
 6     public static Map&lt;String, List&lt;String&gt;&gt; computeAdjacentWords(<br />
 7             List&lt;String&gt; theWords) {<br />
 8         Map&lt;String, List&lt;String&gt;&gt; adjWords = new TreeMap&lt;&gt;();<br />
 9         Map&lt;Integer, List&lt;String&gt;&gt; wordsByLength = new TreeMap&lt;&gt;();//单词分类,Key表示单词长度，Value表示长度相同的单词集合<br />
10<br />
11         for (String word : theWords)<br />
12             update(wordsByLength, word.length(), word);<br />
13<br />
14         for (List&lt;String&gt; groupWords : wordsByLength.values()) {//分组处理单词<br />
15             String[] words = new String[groupWords.size()];<br />
16             groupWords.toArray(words);<br />
17<br />
18             for (int i = 0; i &lt; words.length; i++)<br />
19                 for (int j = i + 1; j &lt; words.length; j++)//只在一个组内所有的单词之间进行比较<br />
20                     if (oneCharOff(words[i], words[j])) {<br />
21                         update(adjWords, words[i], words[j]);<br />
22                         update(adjWords, words[j], words[i]);<br />
23                     }<br />
24<br />
25         }<br />
26         return adjWords;<br />
27     }</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>第11行至12行，完成单词分类，将单词按长度分类保存在一个Map中。Map的Key表示单词长度，Value表示所有长度相同的单词集合。如: &lt;4, five,line,good,high....&gt;</p>
<p><strong>第18行至19行的for循环，现在只需要对一个分类里面的所有单词进行比较了。而上面第2点（算法分析）中贴出的computeAdjacentWords2()方法中的第6、7行for循环则是对所有的单词进行遍历。</strong></p>
<p>可以看出，改进后的算法比较的次数少了。但是从时间复杂度的角度来看，仍是O（N^2）。且额外用了一个Map&lt;Integer, List&lt;String&gt;&gt;来保存每个分类。</p>
<p><strong>四，总结</strong></p>
<p>这个单词转换问题让我认识到了图论算法的重要性。以前觉得图的算法高大上，遥不可及，原来它的应用如此实在。</p>
<p>Dijkstra算法是一个典型的贪心算法。对于带权的有向图的Dijkstra算法实现需要用到最小堆。最小堆的DelMin操作最坏情况下的复杂度为O(logN)，很符合Dijkstra中贪心选取下一个距离最小的顶点。<strong>其次，要注意的是：当选取了某个顶点之后，该顶点的所有邻接点的距离都可能被更新，这里需要进行堆调整，可视为将这些邻接点执行decreaseKey(weight)操作。但是，有个问题，我们需要找到该顶点的所有邻接点！而对最小堆中的某个元素进行查找操作是低效的！</strong>(为什么网上大部分的基于最小堆实现的Dijkstra算法都没有考虑查找邻接点且对它执行decreaseKey操作????)<strong>因此，Dijkstra算法的实现才会借助对查找效率更好的斐波拉契堆或者配对堆来实现。</strong></p>
<p>其次，对待求解的大问题进行分类，将大问题分解成若干小的类别的问题，这是一种分治的思想。只&rdquo;比较&ldquo;（处理）相关的元素而不是&rdquo;比较&ldquo;所有的元素，有效地减少了程序的时间复杂度。</p>
<p><strong>五，完整代码实现</strong></p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">  1 import java.io.BufferedReader;<br />
  2 import java.io.File;<br />
  3 import java.io.FileReader;<br />
  4 import java.io.IOException;<br />
  5 import java.util.ArrayList;<br />
  6 import java.util.HashMap;<br />
  7 import java.util.LinkedList;<br />
  8 import java.util.List;<br />
  9 import java.util.Map;<br />
 10 import java.util.Queue;<br />
 11 import java.util.TreeMap;<br />
 12<br />
 13 public class WordLadder {<br />
 14<br />
 15     /*<br />
 16      * 从文件中将单词读入到List&lt;String&gt;. 假设一行一个单词,单词没有重复<br />
 17      */<br />
 18     public static List&lt;String&gt; read(final String filepath) {<br />
 19         List&lt;String&gt; wordList = new ArrayList&lt;String&gt;();<br />
 20<br />
 21         File file = new File(filepath);<br />
 22         FileReader fr = null;<br />
 23         BufferedReader br = null;<br />
 24         String lines = null;<br />
 25         String word = null;<br />
 26         try {<br />
 27             fr = new FileReader(file);<br />
 28             br = new BufferedReader(fr);<br />
 29             String line = null;<br />
 30             int index = -1;<br />
 31             while ((lines = br.readLine()) != null) {<br />
 32                 // word = line.substring(0, line.indexOf(" ")).trim();<br />
 33                 line = lines.trim();<br />
 34                 index = line.indexOf(" ");<br />
 35                 if (index == -1)<br />
 36                     continue;<br />
 37                 word = line.substring(0, line.indexOf(" "));<br />
 38                 wordList.add(word);<br />
 39             }<br />
 40         } catch (IOException e) {<br />
 41             e.printStackTrace();<br />
 42         } finally {<br />
 43             try {<br />
 44                 fr.close();<br />
 45                 br.close();<br />
 46             } catch (IOException e) {<br />
 47<br />
 48             }<br />
 49         }<br />
 50<br />
 51         return wordList;<br />
 52     }<br />
 53<br />
 54     /**<br />
 55      * 根据单词构造邻接表<br />
 56      * @param theWords 包含所有单词List<br />
 57      * @return Map&lt;String, List&lt;string&gt;&gt;key:表示某个单词, Value:与该单词只差一个字符的单词<br />
 58      */<br />
 59     public static Map&lt;String, List&lt;String&gt;&gt; computeAdjacentWords(<br />
 60             List&lt;String&gt; theWords) {<br />
 61         Map&lt;String, List&lt;String&gt;&gt; adjWords = new TreeMap&lt;&gt;();<br />
 62         Map&lt;Integer, List&lt;String&gt;&gt; wordsByLength = new TreeMap&lt;&gt;();<br />
 63<br />
 64         for (String word : theWords)<br />
 65             update(wordsByLength, word.length(), word);<br />
 66<br />
 67         for (List&lt;String&gt; groupWords : wordsByLength.values()) {<br />
 68             String[] words = new String[groupWords.size()];<br />
 69             groupWords.toArray(words);<br />
 70<br />
 71             for (int i = 0; i &lt; words.length; i++)<br />
 72                 for (int j = i + 1; j &lt; words.length; j++)<br />
 73                     if (oneCharOff(words[i], words[j])) {<br />
 74                         update(adjWords, words[i], words[j]);<br />
 75                         update(adjWords, words[j], words[i]);<br />
 76                     }<br />
 77<br />
 78         }<br />
 79         return adjWords;<br />
 80     }<br />
 81<br />
 82     public static Map&lt;String, List&lt;String&gt;&gt; computeAdjacentWords2(List&lt;String&gt; theWords){<br />
 83         Map&lt;String, List&lt;String&gt;&gt; adjWords = new TreeMap&lt;&gt;();<br />
 84         String[] words = new String[theWords.size()];<br />
 85         words = theWords.toArray(words);<br />
 86<br />
 87         for(int i = 0; i &lt; words.length; i++)<br />
 88             for(int j = i+1; j &lt; words.length; j++)<br />
 89                 if(oneCharOff(words[i], words[j]))<br />
 90                 {<br />
 91                     update(adjWords, words[i], words[j]);//无向图,i--j<br />
 92                     update(adjWords, words[j], words[i]);//j--i<br />
 93                 }<br />
 94         return adjWords;<br />
 95     }<br />
 96<br />
 97<br />
 98     //判断两个单词 只替换一个字符变成另一单词<br />
 99     private static boolean oneCharOff(String word1, String word2) {<br />
100         if (word1.length() != word2.length())//单词长度不相等,肯定不符合条件.<br />
101             return false;<br />
102         int diffs = 0;<br />
103         for (int i = 0; i &lt; word1.length(); i++)<br />
104             if (word1.charAt(i) != word2.charAt(i))<br />
105                 if (++diffs &gt; 1)<br />
106                     return false;<br />
107         return diffs == 1;<br />
108     }<br />
109<br />
110     //将单词添加到邻接表中<br />
111     private static &lt;T&gt; void update(Map&lt;T, List&lt;String&gt;&gt; m, T key, String value) {<br />
112         List&lt;String&gt; lst = m.get(key);<br />
113         if (lst == null) {//该 Key是第一次出现<br />
114             lst = new ArrayList&lt;String&gt;();<br />
115             m.put(key, lst);<br />
116         }<br />
117         lst.add(value);<br />
118     }<br />
119<br />
120<br />
121 /**<br />
122  * 使用Dijkstra算法求解从 start 到 end 的最短路径<br />
123  * @param adjcentWords 保存单词Map,Map&lt;String, List&lt;string&gt;&gt;key:表示某个单词, Value:与该单词只差一个字符的单词<br />
124  * @param start 起始单词<br />
125  * @param end 结束单词<br />
126  * @return 从start 转换成 end 经过的中间单词<br />
127  */<br />
128     public static List&lt;String&gt; findChain(Map&lt;String, List&lt;String&gt;&gt; adjcentWords, String start, String end){<br />
129         Map&lt;String, String&gt; previousWord = new HashMap&lt;String, String&gt;();//Key:某个单词,Value:该单词的前驱单词<br />
130         Queue&lt;String&gt; queue = new LinkedList&lt;&gt;();<br />
131<br />
132         queue.offer(start);<br />
133         while(!queue.isEmpty()){<br />
134             String preWord = queue.poll();<br />
135             List&lt;String&gt; adj = adjcentWords.get(preWord);<br />
136<br />
137             for (String word : adj) {<br />
138                 //代表这个word的'距离'(前驱单词)没有被更新过.(第一次遍历到该word),每个word的'距离'只会被更新一次.<br />
139                 if(previousWord.get(word) == null){//理解为什么需要if判断<br />
140                     previousWord.put(word, preWord);<br />
141                     queue.offer(word);<br />
142                 }<br />
143<br />
144             }<br />
145         }<br />
146         previousWord.put(start, null);//记得把源点的前驱顶点添加进去<br />
147         return geChainFromPreviousMap(previousWord, start, end);<br />
148     }<br />
149<br />
150     private static List&lt;String&gt; geChainFromPreviousMap(Map&lt;String, String&gt; previousWord, String start, String end){<br />
151         LinkedList&lt;String&gt; result = null;<br />
152<br />
153         if(previousWord.get(end) != null){<br />
154             result = new LinkedList&lt;&gt;();<br />
155             for(String pre = end; pre != null; pre = previousWord.get(pre))<br />
156                 result.addFirst(pre);<br />
157         }<br />
158         return result;<br />
159     }<br />
160 }</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>处理的单词TXT文件格式如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/715283/201604/715283-20160429202110191-1433387156.png" /></p>
</div>
<div>&nbsp;</div>
<div>
<div>http://www.cnblogs.com/hapjin/p/5445370.html</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2wdwwq.html">C&num;Excel文件加密实现，支持xlsx、docx、pptx（C&num;&bsol;Net&bsol;Asp&period;Net）</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdepp79.html">Newtonsoft&period;Json 自定义 解析协议</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvev4x9.html">web移动端fixed布局和input等表单的爱恨情仇 - 终极BUG，完美解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/r931nn08.html">php数字操作，高精度函数，保留计算结果小数位</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnkd7e8.html">SimpleDateFormat&lpar;&rpar;简单了解</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v2l448.html">python 函数对象&lpar;函数式编程 lambda、map、filter、reduce&rpar;、闭包&lpar;closure&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd0kdr8.html">【百度地图-安卓SDK】从头开始写android程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydgnjxq.html">自己学会汉化DevExpress控件&lbrack;转&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmr5vl9.html">菜单练习-关机&amp;amp&semi;取消</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn6x5rq.html">java中时间差计算</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j03mo0q.html">Manor</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn13jx28.html">TransactionScope使用说明 【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdemmlj9.html">mysql函数操作&lpar;4&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zorrg9.html">5款最好用的开源Web快速开发工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zm0oe9.html">Intellij IDEA 建立文件夹目录问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdxg7z9.html">DotNet友元程序集解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zo0e59.html">学习ASP&period;NET Core Razor 编程系列十八&mdash;&mdash;并发解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd1mld9.html">Codeforces Round &num;524 &lpar;Div&period; 2&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m22y2rq.html">安装MySQL提示&OpenCurlyDoubleQuote;请键入 NET HELPMSG 3534 以获得更多的帮助&rdquo;的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwl0479.html">解决VC&plus;&plus;6&period;0打开文件或添加文件到工程出错的问题</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9jzjkp08.html">基于JSP&plus;SERVLET的新闻发布系统&lpar;一&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv15ge1q.html">javascript笔记整理（对象的继承顺序、分类）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zog5kxq.html">css图片上下垂直居中</a>
			</li>
						<li><a href="https://www.batexi.com/a/8memodoq.html">通过cmd命令安装、卸载、启动和停止Windows Service（InstallUtil&period;exe）-大壮他哥</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj1jpk8.html">Windows Azure入门教学系列 &lpar;一&rpar;&colon; 创建第一个WebRole程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1v1gyq.html">js点击button按钮跳转到另一个新页面</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp1jvj9.html">php使用 &lowbar;before&lowbar;index&lpar;&rpar; 来实现访问页面前&comma;判断登录</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zyj6j9.html">cocos2d-x游戏开发系列教程-坦克大战游戏启动界面的编写</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj1d0j8.html">如何将自定义标签封装成一个Jar包</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jwxrv8.html">js监听滚动条 回到顶端</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
